  import {
    select,
    dsv,
    extent,
    scaleLinear,
    scaleTime,
    axisLeft,
    axisBottom} from 'd3';

  dsv(',','data.csv').then(data => {
    data.forEach(d => {
      d.running_total = +d.running_total
    });
    render(data);
  });

  const titleText = 'Rebrickable Lego Sets by Year';

  const svg = select('svg');

  const width = +svg.attr('width');
  const height = +svg.attr('height');

  const render = data => {
    const xValue = d => Date.parse(d.year);
    const yValue = d => d.running_total;
    const year = d => d.year;
    const margin = {top:50, right:30, bottom:50, left:80};
    const innerWidth = width - margin.left - margin.right;
    const innerHeight = height - margin.top - margin.bottom;

     const xScale = scaleTime()
      .domain(extent(data, xValue))
      .range([0, innerWidth]);

    const yScale = scaleLinear()
      .domain(extent(data, yValue))
      .range([innerHeight,0]);

    const g = svg.append('g')
      .attr('transform', `translate(${margin.left},${margin.top})`);

     g.append('g').call(axisBottom(xScale).ticks(d3.timeYear.every(3)))
      .attr('transform', `translate(0,${innerHeight})`);

     g.append('g')
      .call(axisLeft(yScale));

    g.selectAll('rect').data(data)
      .enter().append('rect')
        .attr('x', d => xScale(xValue(d)))
        .attr('width', '8')
        .attr('y', d => yScale(yValue(d)))
        .attr('height', d => innerHeight - (yScale(yValue(d))))
        .attr('transform','scale(1,1)');

    g.append('text')
        .attr('class', 'title')
        .attr('x', innerWidth -  8*margin.left)
        .attr('y', innerHeight - 8*margin.bottom)
        .text(titleText);
    g.append('text')
        .attr('x', innerWidth - margin.left)
        .attr('y', innerHeight + margin.bottom)
        .text('atran97')
  };

